SystemOrganization addCategory: #'HighOctane-Sandbox'!
SystemOrganization addCategory: #'HighOctane-Tests'!
SystemOrganization addCategory: #'HighOctane-Turtle'!

!String methodsFor: '*highoctane' stamp: 'PhilippeBack 3/19/2012 22:09'!
repeat: anInteger 
    | writer |

   writer := WriteStream on: String new.
   anInteger timesRepeat: [writer nextPutAll: self].
   ^writer contents
! !

TestCase subclass: #AstroidMorphTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Tests'!

!AstroidMorphTests methodsFor: 'testing' stamp: 'PhilippeBack 3/10/2012 17:18'!
testHowToDoAnAssert
	| data |
	data := True.
	self assert: data.! !

RectangleMorph subclass: #HOAstroidMorph
	instanceVariableNames: 'nombreDeDroites longueur drawingColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOAstroidMorph commentStamp: 'PhilippeBack 3/11/2012 08:40' prior: 0!
An Astroid shaped Morph.

Description:
  This class demonstrates an astroid mathematical object.

Collaborations: Canvas

Usage:
  (AstroidMorph new) openInWorld.
!

!HOAstroidMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:44'!
example
	|m|
	
	m := HOAstroidMorph new openInWorld.
	
! !

!HOAstroidMorph methodsFor: 'drawing' stamp: 'PhilippeBack 3/10/2012 17:22'!
areasRemainingToFill: aRectangle
	"Could be improved by quick check of inner rectangle"

	^ Array with: aRectangle! !

!HOAstroidMorph methodsFor: 'private' stamp: 'PhilippeBack 1/2/2011 20:47'!
configureLongueur: aLongueur etNombreDeDroites: aNombreDeDroites
  longueur :=  aLongueur.
  nombreDeDroites := aNombreDeDroites.
  drawingColor := Color red.
! !

!HOAstroidMorph methodsFor: 'initialization' stamp: 'PhilippeBack 3/10/2012 17:51'!
degrees: aNumber
"Do nothing"! !

!HOAstroidMorph methodsFor: 'drawing' stamp: 'PhilippeBack 3/18/2012 22:11'!
drawOn: aCanvas

  | t xa xc xb yc ya yb |

    "super drawOn: aCanvas."
    
    xc := self left + (self bounds width / 2).
   yc := self top + (self bounds height / 2).
   
  ya := yc.
  xb := xc.

  "aCanvas line: (self topLeft) to: xc@yc color: Color green."

0 to: (longueur - 1) do: [:i | t := (2* (Float pi) * i) / nombreDeDroites.
	xa := xc + (longueur * t cos).
	yb := yc + (longueur * t sin).
	
	aCanvas line: (xa@ya) to: (xb@yb) color: self color.
	]
   



! !

!HOAstroidMorph methodsFor: 'drawing' stamp: 'PhilippeBack 3/10/2012 17:49'!
extent: aPoint
"Do nothing"! !

!HOAstroidMorph methodsFor: 'initialization' stamp: 'PhilippeBack 3/10/2012 17:49'!
initialize
  super initialize.
  super extent: 500@500.
  self configureLongueur:  ((self width) /2)+10 etNombreDeDroites: 50.
  "We need to put some extra to avoid ugly trails left by the +10 in the morph."
  super extent: 520@520.


! !

RectangleMorph subclass: #HOKeyboardHandlingMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOKeyboardHandlingMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:47'!
example
  HOKeyboardHandlingMorph new openInWorld.! !

!HOKeyboardHandlingMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:45'!
handlesKeyboard: evt
   ^ true
! !

!HOKeyboardHandlingMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:51'!
keyDown: anEvent
"Handle a key down event. ."
  anEvent keyCharacter = $a
     ifTrue: [self doSomething].
  anEvent keyCharacter = $q
     ifTrue: [self doAnotherOne]! !

!HOKeyboardHandlingMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:45'!
mouseEnter: evt
   evt hand keyboardFocus: self ! !

!HOKeyboardHandlingMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:45'!
mouseLeave: evt
   evt hand releaseKeyboardFocus: self ! !

RectangleMorph subclass: #HOTestMorph
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOTestMorph commentStamp: 'PhilippeBack 3/10/2012 17:34' prior: 0!
A test morph that moves and react to the mouse.

HOTestMorph new openInWorld.!

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:33'!
drawOn: aCanvas
    | colors |
    colors := Color wheel: 10.
    colors withIndexDo: [:c :i |
        aCanvas fillOval: (self bounds insetBy: self width // 25 * i + 1)
                color: c].
! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:33'!
handlesMouseDown: evt
    ^ true
! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:31'!
initialize
    super initialize.
    path := OrderedCollection new.! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:36'!
mouseDown: evt
    self startAnimation.! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:33'!
startAnimation
    path := OrderedCollection new.
    0 to: 29 do: [:i | path add: self position + (0@(i squared / 5.0))].
    path := path, path reversed.
    self startStepping.! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:32'!
step
    path size > 0 ifTrue: [self position: path removeFirst].! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:32'!
stepTime
    ^ 50! !

ImageMorph subclass: #TurtleMorph
	instanceVariableNames: 'tilt size pen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Turtle'!

!TurtleMorph commentStamp: 'RJH 4/16/2008 03:24' prior: 0!
With TurtleMorph you can add methods to the class TurtleMorph and so simply programme new turtle actions. The normal kind of behaviour that occurs with scripting now happens with methods. This means that initial teaching of Smalltalk can be done using a typical turtle of the kind met in LOGO programming.
[Morphic is usually driven by scripts, but when you try to programme methods you have to take account of the fiddles that the programmers did to keep morphs efficient. Morphs divide into two parts, costume and player. For efficiency morphs only get given the player only when needed- so for example with the forward: message, this is implemented in the player class and not in the morph class, so the morph has to create a player in order to deal with the forward: message. This happens automatically when using the etoys system, but not if you write scripts in methods. TurtleMorph traps any messages that should go to the player and makes sure the necessary player exists before passing the message on. Without this feature, you would have to know where you were directing the message and use 'assuredPlayer' to make sure the player exists. TurtleMorph by-passes this, so you can write forward: and send it straight to the TurtleMorph WITHOUT having to know that actually the implementation passes it to a player that may or may not exist!!]
There is more work to be done on this - including making the turtle look better and be able to shuffle along visibly.!

!TurtleMorph methodsFor: 'system' stamp: 'PhilippeBack 3/28/2012 16:30'!
doesNotUnderstand: aMessage
  "TODO: add behaviors to the TurtleMorph"
	(self respondsTo: aMessage selector) ifTrue: [
		^self perform: aMessage selector withArguments: aMessage arguments].
	^super doesNotUnderstand: aMessage! !

!TurtleMorph methodsFor: 'example' stamp: 'PhilippeBack 3/28/2012 17:17'!
draw
"TODO: use this to manage the turtle as an example"
| myPen |
myPen := self pen. "Create a new Pen for drawing" 
myPen up. "Don't draw while setting it up"
"Set up the Pen with the Boxes' characteristics" 
myPen goto: position.
myPen turn: tilt.
myPen color: (Color black).
"Now put the Pen down and draw the box." myPen down.
4 timesRepeat: [myPen go: size; turn: 90].! !

!TurtleMorph methodsFor: 'example' stamp: 'PhilippeBack 3/28/2012 17:25'!
forward2: aSize
	"TODO: use this to manage the turtle as an example"

	| myPen |
	myPen := self pen.	"Create a new Pen for drawing"
	myPen up.	"Don't draw while setting it up"	"Set up the Pen with the Boxes' characteristics"
	myPen goto: self position.
	myPen turn: self tilt.
	myPen color: Color black.	"Now put the Pen down and draw the box."
	myPen down.
	myPen go: aSize! !

!TurtleMorph methodsFor: 'turtle' stamp: 'PhilippeBack 3/28/2012 17:29'!
forward: aDistance 
	self pen go: aDistance.! !

!TurtleMorph methodsFor: 'system' stamp: 'RJH 4/15/2008 01:06'!
initialize

	super initialize.
	self image: self turtleForm! !

!TurtleMorph methodsFor: 'turtle' stamp: 'RJH 4/15/2008 02:57'!
north
	self heading: 0! !

!TurtleMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 17:34'!
pen
	| aPen |
	aPen := pen ifNil: [ Pen new ].
	aPen goto: self position. "Go where the turtle is with the pen"
	^ aPen! !

!TurtleMorph methodsFor: 'turtle' stamp: 'PhilippeBack 3/28/2012 17:27'!
penDown
	self pen down.! !

!TurtleMorph methodsFor: 'turtle' stamp: 'PhilippeBack 3/28/2012 17:28'!
penUp
	self pen up.! !

!TurtleMorph methodsFor: 'example' stamp: 'RJH 4/15/2008 02:57'!
square: size
	4 timesRepeat: [
		self forward: size.
		self turn: 90]! !

!TurtleMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 17:22'!
tilt
  ^ tilt ifNil: [0]! !

!TurtleMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 17:29'!
turn: anAngle
  tilt := anAngle.
  ^tilt! !

!TurtleMorph methodsFor: 'system' stamp: 'rjh 3/12/2010 01:24'!
turtleForm
	"Original file: turtle.png"
	^ Form
		extent: 33 @ 36
		depth: 32
		fromArray:   #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 4292240128 4292240128 4292240128 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
		offset: 0 @ 0
! !

Morph subclass: #HOCanvasMorph
	instanceVariableNames: 'drawBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOCanvasMorph commentStamp: 'PhilippeBack 3/18/2012 17:40' prior: 0!
Allows to draw on a canvas without subclassing.
All drawing code goes to a Block.!

!HOCanvasMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/26/2012 22:50'!
astroide
	"Some mathematical fun"

	| m |
	m := HOCanvasMorph new openInWorld.	"to draw:"
	m
		drawBlock: [ :aCanvas | 
			| t xa xc xb yc ya yb longueur nombreDeDroites |
			longueur := 150.
			nombreDeDroites := 30.	"super drawOn: aCanvas."
			xc := (200).
			yc := (200).
			ya := yc.
			xb := xc.	"aCanvas line: (self topLeft) to: xc@yc color: Color green."
			0
				to: longueur - 1
				do:
					[ :i | 
					t := 2 * Float pi * i / nombreDeDroites.
					xa := xc + (longueur * t cos).
					yb := yc + (longueur * t sin).
					aCanvas line: xa @ ya to: xb @ yb color: Color green ]
		 ]! !

!HOCanvasMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 16:51'!
example
"Then use like"
|m|

    m := HOCanvasMorph new openInWorld.

"to draw:"

    m drawBlock: [:c |
        c line: 10@10 to: 100@100 color: Color red
    ]! !

!HOCanvasMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 18:20'!
napperons
	"Some mathematical fun"

	| m |
	m := HOCanvasMorph new openInWorld.	"to draw:"
	m
		drawBlock: [ :aCanvas | 
			| n r t xa xc xb yc ya yb longueur nombreDeDroites |
			longueur := 150.
			nombreDeDroites := 30.	"super drawOn: aCanvas."
			xc := 200.
			yc := 200.
			n := 15.
			r := 100.
			0 to: n - 2 do: [ :i | 
				t := 2 * Float pi * i / n.
				i + 1 to: n - 1 do: [ :j | 
					| tj |
					tj := 2 * Float pi * j / n.
					xa := xc + (r * t cos).
					ya := yc + (r * t sin).
					xb := xc + (r * tj cos).
					yb := yc + (r * tj sin).
					(aCanvas asBalloonCanvas) line: xa @ ya to: xb @ yb color: Color green ] ] ]! !

!HOCanvasMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 16:49'!
drawBlock: aBlock
    drawBlock := aBlock.
    self changed.

! !

!HOCanvasMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 18:34'!
drawOn: aCanvas
    super drawOn: aCanvas.
    
    drawBlock ifNotNil: [
        aCanvas
            translateBy: self bounds origin
            clippingTo: self bounds
            during: [:canvas | drawBlock value: canvas]]
! !

!HOCanvasMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 16:48'!
initialize
    super initialize.
    self color: Color white.
    self extent: 400@400.
! !

Morph subclass: #HOTestMorphic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOTestMorphic methodsFor: 'drawing' stamp: 'PhilippeBack 3/28/2012 12:42'!
drawOn: aCanvas
   aCanvas
      fillOval: self bounds
      color: Color red! !

!HOTestMorphic methodsFor: 'event handling' stamp: 'PhilippeBack 3/28/2012 12:41'!
handlesKeyboard: aKeyBoardEvent
   ^aKeyBoardEvent isKeystroke! !

!HOTestMorphic methodsFor: 'event handling' stamp: 'PhilippeBack 3/28/2012 12:42'!
keyStroke: anEvent
   Transcript 
      show: 'You pressed key ';
      show: anEvent keyCharacter;
      cr.! !

!HOTestMorphic methodsFor: 'stepping and presenter' stamp: 'PhilippeBack 3/28/2012 12:41'!
step
   self world bounds bottom > self bottom
      ifTrue:[self bottom: (self bottom + 3)]! !

!HOTestMorphic methodsFor: 'stepping and presenter' stamp: 'PhilippeBack 3/28/2012 12:44'!
stepTime
  ^50! !

Object subclass: #HOCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

HOCounter class
	instanceVariableNames: 'count'!

HOCounter class
	instanceVariableNames: 'count'!

!HOCounter class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:20'!
new
  "The usual stanza"
  ^super new initialize! !

!HOCounter class methodsFor: 'instance creation' stamp: 'PhilippeBack 3/28/2012 12:30'!
openInWorld 
  "Just a shorthand for getting something out of the class."
  ^self new openInWorld.! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:32'!
add: amount
	count := count + amount.
	self changed: #printString! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:33'!
count: aNumberOrText
	count := aNumberOrText asNumber.
	^ true! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:33'!
decrease
	self add: -1! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:34'!
increase
	self add: 1! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:34'!
initialize
	count := 0! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:34'!
openInWorld
	| window increaseButton decreaseButton display |
	window := SystemWindow labelled: 'Counter'.
	window model: self.
	increaseButton := PluggableButtonMorph new
		model: self;
		action: #increase;
		label: 'Increase';
		borderWidth: 1.
	decreaseButton := PluggableButtonMorph new
		model: self;
		action: #decrease;
		label: 'Decrease';
		borderWidth: 1.
	display := PluggableTextMorph on: self text: #printString accept: #count:.
	window addMorph: display frame: (0 @ 0 extent: 1 @ 0.5).
	window addMorph: increaseButton frame: (0 @ 0.5 extent: 0.5 @ 0.5).
	window addMorph: decreaseButton frame: (0.5 @ 0.5 extent: 0.5 @ 0.5).
	window openInWorld! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:31'!
printOn: aStream
  aStream nextPutAll: count printString! !

Object subclass: #HOLivreHeros
	instanceVariableNames: 'story window toolbar storyarea dicearea textarea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOLivreHeros commentStamp: 'PhilippeBack 3/19/2012 22:00' prior: 0!
Runs a story.!

!HOLivreHeros class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/19/2012 13:23'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'HOLivreHeros')
	       icon: UITheme current solidMenuIcon;
			parent: #'High Octane Experiments';
			action: [self new.].! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/19/2012 23:08'!
dicearea
	^ dicearea
		ifNil: [ 
			| area |
			area :=  RectangleMorph new.
			dicearea:=area.
		]! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 3/19/2012 23:54'!
initialize
	super initialize.
	
	self installToolbar.
	self installTextArea.
	self installStoryArea.
	self installDiceArea.

    self textarea textMorph color: Color red.
    self dicearea color: Color yellow.
    self storyarea color: Color magenta.

    self textarea.

	"window is created in a lazy way, when accessed."
	self window openInWorld.
	"self window  extent: 300@250"! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 3/19/2012 23:05'!
installDiceArea
	self window addMorph: self dicearea frame: (0 @ 0.90 corner: 1 @ 1)! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 3/19/2012 23:11'!
installStoryArea

	self window 
		addMorph: self storyarea frame: (0@0.60 corner: 1@0.9)
		
! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 3/19/2012 23:39'!
installTextArea

    self window addMorph: self textarea frame: (0@0.10 corner: 1@0.60).
    
! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 3/19/2012 23:00'!
installToolbar
	self window
		addMorph: self toolbar
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ self toolbar minExtent y))! !

!HOLivreHeros methodsFor: 'actions' stamp: 'PhilippeBack 3/20/2012 00:21'!
next
	self textarea editString: self story nextEpisode.
! !

!HOLivreHeros methodsFor: 'actions' stamp: 'PhilippeBack 3/19/2012 15:46'!
quit
   Transcript nextPutAll:'Quitting';cr.
	self shouldBeImplemented.! !

!HOLivreHeros methodsFor: 'actions' stamp: 'PhilippeBack 3/19/2012 15:47'!
rollDice
	Transcript nextPutAll: 'Rolling Dice';cr.
	self shouldBeImplemented.! !

!HOLivreHeros methodsFor: 'actions' stamp: 'PhilippeBack 3/19/2012 15:46'!
runbook
	Transcript nextPutAll: 'Running the book';cr.
	self shouldBeImplemented.! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/20/2012 00:11'!
story
	^ story ifNil: [ story := HOLivreHerosStory new ]! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/19/2012 23:08'!
storyarea
	^ storyarea
		ifNil: [ 
			| area |
			area :=  RectangleMorph new.
			storyarea:=area.
		]! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/19/2012 23:38'!
textarea
	^ textarea
		ifNil: [ 
			"textarea := RectangleMorph new."

	          | textmorph |
			textmorph := PluggableTextMorph new
				on: self
				text: nil
				accept: nil
				readSelection: nil
				menu: nil.
			textmorph setText: 'Hello world'.
			textarea := textmorph ]! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/19/2012 15:32'!
toolbar
	^ toolbar
		ifNil: [ 
			| tools |
			tools := self window
				newToolbar:
					{(self window
						newButtonFor: self
						getState: nil
						action: #runbook
						arguments: nil
						getEnabled: nil
						labelForm: (MenuIcons smallDoItIcon scaledToSize: 16 @ 16)
						help: 'Run.').
					(self window
						newButtonFor: self
						getState: nil
						action: #next
						arguments: nil
						getEnabled: nil
						labelForm: (MenuIcons smallForwardIcon scaledToSize: 16 @ 16)
						help: 'Forward').
					(self window
						newButtonFor: self
						getState: nil
						action: #quit
						arguments: nil
						getEnabled: nil
						labelForm: (MenuIcons smallQuitIcon scaledToSize: 16 @ 16)
						help: 'Quit.')}.
			toolbar := self window newToolDockingBar addMorph: tools ]! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/19/2012 23:34'!
window
	^ window
		ifNil: [ 
			window := StandardWindow labelled: 'High Octane Heros Book Runner'.	
			window announcer
				on: WindowResizing
				do: [ :ann | 
					self storyarea extent: ann newSize.
					self textarea extent: ann newSize.
					self toolbar extent: ann newSize.
					self dicearea extent: ann newSize.
					].
			window ]! !

Object subclass: #HOLivreHerosAction
	instanceVariableNames: 'title target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOLivreHerosAction commentStamp: 'PhilippeBack 3/20/2012 23:47' prior: 0!
Represents an action, formed of a text and a target number.!

!HOLivreHerosAction methodsFor: 'accessing' stamp: 'PhilippeBack 3/20/2012 23:46'!
target: aSmallInteger 
	target := aSmallInteger.! !

!HOLivreHerosAction methodsFor: 'accessing' stamp: 'PhilippeBack 3/20/2012 23:46'!
title: aByteString 
	title := aByteString.! !

HOLivreHerosAction subclass: #HOLivreHerosBattleAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOLivreHerosBattleAction commentStamp: 'PhilippeBack 3/20/2012 23:49' prior: 0!
Represents a battle action with various outcomes based on the final result. !

Object subclass: #HOLivreHerosStory
	instanceVariableNames: 'episodes currentEpisode episode1actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOLivreHerosStory commentStamp: 'PhilippeBack 3/20/2012 23:50' prior: 0!
Represents the logic and body of the story.

Instance Variables:
	episodes	<Collection>
	currentEpisode	<Number>
	episode1actions	<Collection>!

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 00:08'!
begin
  "start the story"
  currentEpisode = -1.
  ^self! !

!HOLivreHerosStory methodsFor: 'episodes' stamp: 'PhilippeBack 3/20/2012 23:14'!
episode1
  ^'Alors que vous parcourez comme tous les matins les quelques centaines de mtres qui vous sparent de votre bureau, vous ne pouvez vous dfendre d''un indfinissable malaise.'.! !

!HOLivreHerosStory methodsFor: 'episodes' stamp: 'PhilippeBack 3/20/2012 23:58'!
episode1actions
  ^episode1actions ifNil: [ 
	  episode1actions := OrderedCollection new.
	  
	episode1actions add: (self newEpisodeActionWithTitle: 'Vous diriger vers le groupe pour tenter d''arrter la dispute?' andTarget:263 ).
	episode1actions add: (self newEpisodeActionWithTitle: 'Vous prcipiter vers le parc des Bogues  la suite de la voiture de police?' andTarget:289 ).
	episode1actions add: (self newEpisodeActionWithTitle: 'Acheter le journal pour avoir des dtail sur le cambriolage?' andTarget:228 ).
	episode1actions add: (self newEpisodeActionWithTitle: 'Continuer votre chemin jusqu'' votre bureau?' andTarget:341 ).
	
	  episode1actions.
	]! !

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 00:35'!
initialize
  currentEpisode := 0. 
  episodes := OrderedCollection new.
  #('One upon a time...' 'There was a dragon...' 'And  a lot of other people.' 'But this will be for another time') do: [:each| episodes add: each].
 
  
! !

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 00:07'!
isFinished
  "Tells if the story is over"
  ^currentEpisode = episodes size.! !

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 23:45'!
newEpisodeActionWithTitle: aByteString andTarget: aSmallInteger 
	| action |
	action := HOLivreHerosAction new.
	action title: aByteString; target: aSmallInteger.
	^action ! !

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 00:34'!
nextEpisode
	( currentEpisode < episodes size )
		ifTrue: [ currentEpisode :=currentEpisode + 1 ]
		ifFalse: [ currentEpisode := currentEpisode ].
	^ episodes at: currentEpisode! !

Object subclass: #HOMenus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOMenus commentStamp: 'PhilippeBack 3/19/2012 08:55' prior: 0!
Sample class to show how to add elements to the World menu.
See Class side.

Also, it is interesting to have a look at MenuRegistrationExample, to be used with:

(PragmaMenuBuilder pragmaKeyword: 'worldMenuExample' model: nil) menu popUpInWorld.

The is a bug in the example. Replace the icon problem related line with:
UITheme current solidMenuIcon!

!HOMenus class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/21/2012 18:58'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'High Octane Experiments')
	       icon: UITheme current solidMenuIcon;
			parent: #Root;
			with: [
			  (aBuilder item: #'About...') 
				  order: 0; 
				  action: [UITheme current messageIn: World	text: 'High Octane Rulez!!'	title: 'Experiments in Pharo'].
				(aBuilder item: #'HOAstroidMorph') 
				  order: 1; 
				  action: [HOAstroidMorph new openInWorld].
				(aBuilder item: #'HOCanvasMorph') 
				  order: 2; 
				  action: [HOCanvasMorph example].
				(aBuilder item: #'Theme switch to Vistary') 
				  order: 3; 
				  action: [UIThemeVistary beCurrent].
				(aBuilder item: #'Theme switch to Watery2') 
				  order: 4; 
				  action: [UIThemeWatery2 beCurrent.].
				(aBuilder item: #'Theme switch to GLMUI (pharo)') 
				  order: 5; 
				  action: [GLMUITheme beCurrent.].
				(aBuilder item: #'Theme switch to GLMUI (orange pharo)') 
				  order: 6; 
				  action: [GLMOrangeUITheme beCurrent.].
				(aBuilder item: #'Full Screen') 
				  order: 10; 
				  action: [Display fullScreenOn.].
				(aBuilder item: #'Windowed') 
				  order: 20; 
				  action: [Display fullScreenOff.].	
			].! !

Object subclass: #HOSystemWindowSample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOSystemWindowSample class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 18:33'!
run
	"Adding morphs to a systemwindow (dual)"

	| win win2 m m2 |
	(win := SystemWindow labelled: 'Astroide') openInWorld.
	win addMorph: HOAstroidMorph new frame: (0 @ 0 extent: 1 @ 1).
	(win2 := SystemWindow labelled: 'Napperons') openInWorld.
	m := HOCanvasMorph new.
	m
		drawBlock: [ :aFormCanvas | 
			| n r t xa xc xb yc ya yb longueur nombreDeDroites aCanvas |
			longueur := 150.
			nombreDeDroites := 30.	"super drawOn: aCanvas."
			xc := 200.
			yc := 200.
			n := 15.
			r := 100.
			aCanvas := aFormCanvas asBalloonCanvas.
			aCanvas aaLevel:4.
			aCanvas deferred: true.
			0 to: n - 2 do: [ :i | 
				t := 2 * Float pi * i / n.
				i + 1 to: n - 1 do: [ :j | 
					| tj |
					tj := 2 * Float pi * j / n.
					xa := xc + (r * t cos).
					ya := yc + (r * t sin).
					xb := xc + (r * tj cos).
					yb := yc + (r * tj sin).
					aCanvas asBalloonCanvas line: xa @ ya to: xb @ yb color: Color green ] ].
			aCanvas deferred: false ].
	m2 := HOCanvasMorph new.
	m2
		drawBlock: [ :aFormCanvas | 
			| t xa xc xb yc ya yb longueur nombreDeDroites aCanvas |
			longueur := 150.
			nombreDeDroites := 30.	"super drawOn: aCanvas."
			xc := 200.
			yc := 200.
			ya := yc.
			xb := xc.	"aCanvas line: (self topLeft) to: xc@yc color: Color green."
			aCanvas := aFormCanvas asBalloonCanvas.
			aCanvas aaLevel: 4.
			aCanvas deferred:true.

			0 to: longueur - 1 do: [ :i | 
				t := 2 * Float pi * i / nombreDeDroites.
				xa := xc + (longueur * t cos).
				yb := yc + (longueur * t sin).
				aCanvas line: xa @ ya to: xb @ yb color: Color blue ].
			aCanvas deferred:false. 
			].
	win2 addMorph: m frame: (0 @ 0 extent: 0.5 @ 1).
	win2 addMorph: m2 frame: (0.5 @ 0 extent: 1 @ 1)! !

!HOSystemWindowSample class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/29/2012 23:38'!
runTableLayout
	"Adding morphs to a systemwindow (dual)"

	| win m m2 container aColor aMorph |
	(win := SystemWindow labelled: 'Table Layouting Sample') openInWorld.
	win addMorph: (container := Morph new) frame: (0 @ 0 corner: 1 @ 1).
	container
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight.	"Now we can work..."
	
	#(#red #yellow #green)
		do: [ :colorSelector | 
			aColor := Color perform: colorSelector.
			aMorph := Morph new
				color: aColor;
				hResizing: #spaceFill.
			container addMorph: aMorph ].
		win openInWorld.! !

Object subclass: #HOTextFieldSample
	instanceVariableNames: 'changeCount text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOTextFieldSample commentStamp: 'PhilippeBack 3/28/2012 12:16' prior: 0!
This class is an example of using a PluggableTextMorph. When a user changes and saves text in the text field, the text and its reverse is displayed in the text field. A count of the number of changes is shown before the text. The original text saved by the user is highlighted. !

!HOTextFieldSample class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:04'!
new
  ^super new initialize.! !

!HOTextFieldSample class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:05'!
openInWorld
  ^self new openInWorld.! !

!HOTextFieldSample methodsFor: 'initialization' stamp: 'PhilippeBack 3/28/2012 12:07'!
initialize
	changeCount := 0.
	text := 'Starting'! !

!HOTextFieldSample methodsFor: 'display' stamp: 'PhilippeBack 3/28/2012 12:08'!
openInWorld
	"TextModelExample openInWorld"

	| window display |
	window := SystemWindow labelled: 'Text Example'.
	display := PluggableTextMorph
		on: self
		text: #text
		accept: #text:
		readSelection: #selectTextInterval
		menu: nil.
	window addMorph: display frame: (0 @ 0 extent: 1 @ 1).
	window openInWorld! !

!HOTextFieldSample methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:09'!
selectTextInterval
	| headerSize |
	headerSize := changeCount printString size + 1.
	^ Interval from: headerSize + 1 to: text size / 2 + headerSize! !

!HOTextFieldSample methodsFor: 'accessing' stamp: 'PhilippeBack 3/28/2012 12:09'!
text
   ^changeCount printString , ' ' , text! !

!HOTextFieldSample methodsFor: 'accessing' stamp: 'PhilippeBack 3/28/2012 12:17'!
text: aString 
   "Happens on accept"
   changeCount := changeCount + 1.
   text :=  aString , aString reversed.
   self changed: #text.
   ^true! !

Object subclass: #HOToggle
	instanceVariableNames: 'isOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOToggle class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:58'!
new
   ^super new initialize! !

!HOToggle class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:59'!
openInWorld
   "Toggle openInWorld"
   ^self new openInWorld! !

!HOToggle methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:59'!
changeStateLabel
   ^isOn
      ifTrue:['Turn Off']
      ifFalse:['Turn On']! !

!HOToggle methodsFor: 'initialization' stamp: 'PhilippeBack 3/28/2012 11:59'!
initialize
   isOn := true.! !

!HOToggle methodsFor: 'accessing' stamp: 'PhilippeBack 3/28/2012 11:59'!
isOn
   ^isOn! !

!HOToggle methodsFor: 'display' stamp: 'PhilippeBack 3/28/2012 12:00'!
openInWorld
   | window toggleButton |
   window := SystemWindow labelled: 'Toggle Example'.
   window model: self.
   toggleButton := PluggableButtonMorph 
      on: self
      getState: #isOn
      action: #toggle
      label: #changeStateLabel
      menu: nil.
   toggleButton 
      onColor: Color red
      offColor: Color blue.
   toggleButton
      feedbackColor: Color yellow.      
   window 
      addMorph: toggleButton
      frame: (0@0 extent: 1@1).
   window openInWorld.! !

!HOToggle methodsFor: 'effects' stamp: 'PhilippeBack 3/28/2012 12:00'!
toggle
   isOn := isOn not.
   self changed: #changeStateLabel
! !

Object subclass: #HOTreeFun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

Object subclass: #HOUsefulSamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOUsefulSamples commentStamp: 'PhilippeBack 3/18/2012 17:39' prior: 0!
HOUsefulSamples provides samples of using various useful things in Pharo.
Check the class side.!

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:38'!
dragSample
	|m|
	m := BorderedMorph new.
	m on: #startDrag send: #grabMorph: to: m.
	m on: #click send: #value to:[self inform:'you clicked'].
	m openInWorld
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:36'!
drawingBasicProgramSample
	|lastPt nextPt canvas|
	canvas := Display getCanvas.
    Sensor waitButton.
    lastPt := Sensor cursorPoint.
    [Sensor anyButtonPressed] whileTrue:[
        nextPt := Sensor cursorPoint.
        canvas line: lastPt to: nextPt width: 1 color: Color black.
        lastPt := nextPt.
    ].! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:54'!
formSample2
	| form pen |
	form := Form extent: 150 @ 150 depth: Display depth.
	form fillColor: Color green.
	pen := Pen newOnForm: form.
	pen
		roundNib: 2;
		color: Color red;
		dragon: 9.
	form asMorph openInWorld! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:55'!
formSample3
	| form pen window |
	form := Form extent: 150 @ 150 depth: Display depth.
	form fillColor: Color green.
	pen := Pen newOnForm: form.
	pen
		roundNib: 2;
		color: Color red;
		dragon: 9.
	window := SystemWindow labelled: 'Image'.
	window addMorph: form asMorph frame: (0 @ 0 extent: 1 @ 1).
	window openInWorld! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:37'!
formsSample
|firstForm secondForm |
  firstForm := Form extent: 50@50 depth: Display depth.
  secondForm := Form extent: 50@50 depth: Display depth.
  firstForm fillColor: Color red.
  secondForm fillColor: Color green.
firstForm displayOn: Display at: 100@100.
(Delay forMilliseconds: 1000) wait.
secondForm displayOn: Display at: 100@100.
Display forceDisplayUpdate.
(Delay forMilliseconds: 50) wait.
firstForm displayOn: Display at: 100@100.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 18:43'!
layoutSample1
"How to lay out submorphs

Please read first the well written dynamic essay on Bob's SuperSwiki which you 
find under the name 'MorphLayoutArticle'.

More examples are needed -- add yours here!!

Every Morph now has the capability to layout it's submorphs. Before that only 
the AlignmentMorph could do this, which is now deprecated ( i.e., still in 
place and functioning, but not recommended for use in new code.)

Each Morph can have now its own LayoutPolicy. The new TableLayout corresponds 
to what AlignmentMorph used to do. There is also a ProportionalLayout, which I 
haven't used much. You should also be able to make your own subclasses of 
LayoutPolicy.

Here is some code to lay out some morphs in the new system. You can find other 
layout methods under Morph->layout-properties. Also, play with them from the 
red halo menu of a morph.
"
| m |
m := RectangleMorph new.
m layoutPolicy: TableLayout new.
m listDirection: #leftToRight.
m hResizing: #shrinkWrap; vResizing: #shrinkWrap.
m layoutInset: 20; cellInset: 10.
4 timesRepeat:[ m addMorph: (RectangleMorph new color: (Color red)) ].
m openInWorld.

! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 18:48'!
layoutSample2

| m |
m := RectangleMorph new.
m layoutPolicy: TableLayout new.

m listDirection: #leftToRight. "If you omit this expression you get the default"

"m listDirection: #topToBottom."
m hResizing: #shrinkWrap.
m vResizing: #shrinkWrap.

m addMorph: (EllipseMorph new extent: 40@40; color: Color red).
m addMorph: (EllipseMorph new extent: 50@50; color: Color yellow).
m addMorph: (EllipseMorph new extent: 60@60; color: Color green).
m addMorph: (EllipseMorph new extent: 70@70; color: Color blue).
m openInWorld.

! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 18:48'!
layoutSample3

"Let's start by setting up a background Morph to play with.
(Select this code down to the next comment, and 'DoIt')"

| r e s b |
r := RectangleMorph new.
r color: Color gray.
r position: 10@10.
r extent: 150@200.
r name: 'background'.
r openInWorld.

"OK, now set up our background so that we can put something inside"

r layoutPolicy: TableLayout new. "lay out contents as a table"
r listDirection: #topToBottom. "how we want to place the contents"
r listCentering: #topLeft. "start list at the top"
r wrapCentering: #center. "each item is in the center"
e := EllipseMorph new.
r addMorph: e.

"Now lets add a second item..."

s := RectangleMorph new.
s borderWidth: 1.
s color: Color blue twiceDarker.
r addMorph: s. "note that the new item goes at the top"

"and a third."

b := SimpleButtonMorph new.
b color: Color red;
label: 'remove';
target: r;
actionSelector: #delete;
setBalloonText: 'click to remove the background rectangle and contents'.
r addMorph: b.

"Now let's space things out a bit. Try these one at a time ..."

r cellInset: 2@5. "controls distance between content elements"

r hResizing: #shrinkWrap. "try it and see!!"
r layoutInset: 4@8. "that was a bt too cramped"
r vResizing: #shrinkWrap. "Now we are done"
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 19:07'!
layoutSample4

| r bullet item1 t1 item2 t2 bbar b block item t sm |
r := RectangleMorph new.
r color: Color blue twiceLighter.
r position: 10@10.
r extent: 150@200.
r name: 'background2'.

"OK, now set up our background so that we can put something inside"

r layoutPolicy: TableLayout new. "lay out contents as a table"
r listDirection: #topToBottom. "how we want to place the contents"
r listCentering: #topLeft. "start list at the top"
r wrapCentering: #topLeft.
r hResizing: #rigid.

sm := StringMorph new.

r addMorphBack: (sm contents:'Change to title'; color: Color white; openInWorld).

"bullet by Ned Konz"
bullet := TextMorph new.
bullet beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1).
bullet contentsAsIs: (Character value: 165) asString.
bullet color: Color blue.

item1 := Morph new.
item1 layoutPolicy: TableLayout new.
item1 cellPositioning: #topLeft.
item1 cellInset: 4.
item1 color: Color blue twiceLighter twiceLighter.
item1 listDirection: #leftToRight.
item1 addMorph: bullet.
item1 hResizing: #spaceFill.
item1 vResizing: #shrinkWrap.

t1 := TextMorph new.
t1 layoutPolicy: TableLayout new.
t1 hResizing: #spaceFill.
t1 vResizing: #shrinkWrap.
t1 beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1).
t1 contentsWrapped: 'First list item - aTextMorph'.
t1 autoFit: true.
t1 width: 400.
item1 addMorphBack: t1.
r addMorphBack: item1.
item1 layoutChanged.

"Now lets add a second item..."

item2 := Morph new.
item2 layoutPolicy: TableLayout new.
item2 cellPositioning: #topLeft.
item2 cellInset: 4.
item2 color: Color blue twiceLighter twiceLighter.
item2 listDirection: #leftToRight.
item2 addMorph: bullet duplicate.
item2 hResizing: #spaceFill.
item2 vResizing: #shrinkWrap.

t2 := TextMorph new.
t2 layoutPolicy: TableLayout new.
t2 hResizing: #spaceFill.
t2 vResizing: #shrinkWrap.
t2 beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1).
"t2 borderWidth: 1."
t2 color: Color blue twiceDarker.
t2 contentsWrapped: 'Second list item - text is editable; click and add
text. The box will grow'.
t2 autoFit: true.
item2 addMorphBack: t2.
r addMorphBack: item2.

"and a button bar ..."

bbar := Morph new.
bbar layoutPolicy: TableLayout new.
bbar cellPositioning: #topLeft.
bbar cellInset: 4.
bbar color: Color blue twiceLighter.
bbar listDirection: #leftToRight.
bbar hResizing: #shrinkWrap.
bbar vResizing: #shrinkWrap.

b := SimpleButtonMorph new.
b color: Color yellow;
label: 'remove button bar';
target: bbar;
actionSelector: #delete;
setBalloonText: 'click to remove the button bar'.
bbar addMorph: b.
r addMorph: bbar.

block := [ :r2 |
item := Morph new.
item layoutPolicy: TableLayout new.
item cellPositioning: #topLeft.
item cellInset: 4.
item color: Color blue twiceLighter twiceLighter.
item listDirection: #leftToRight.
item addMorph: bullet duplicate.
item hResizing: #spaceFill.
item vResizing: #shrinkWrap.

t := TextMorph new.
t layoutPolicy: TableLayout new.
t hResizing: #spaceFill.
t vResizing: #shrinkWrap.
t beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1).
t contentsWrapped: 'A list item - aTextMorph'.
t autoFit: true.
t width: 400.
item addMorphBack: t.
r2 addMorphBack: item.
].

b := SimpleButtonMorph new.
b color: Color yellow;
label: 'add other item';
setBalloonText: 'click to add another bullet list item'.
bbar addMorph: b.
b target: block.
b actionSelector: #value:.
b arguments: (Array with: b owner owner).
r addMorph: bbar.

b := SimpleButtonMorph new.
b color: Color yellow;
label: 'X';
setBalloonText: 'click to delete bullet list completely'.
bbar addMorph: b.
b target: r.
b actionSelector: #delete.
r addMorph: bbar.

r cellInset: 3@5. "controls distance between content elements"

r openInWorld.
r hResizing: #shrinkWrap. "try it and see!!"
r layoutInset: 4@8. "that was a bit too cramped"
r vResizing: #shrinkWrap. "Now we are done"
item1 layoutChanged.
item2 layoutChanged.

! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 19:11'!
layoutSample5

Morph new
color: Color green;
extent: 300 @ 300;
layoutPolicy: ProportionalLayout new;
addMorph: (
Morph new color: (Color blue alpha: 0.5)
)
fullFrame: (
LayoutFrame fractions: (0@1 corner: 1 @ 1) offsets: (0@100 negated corner: 0@0)
);

addMorph: (
Morph new
color: (Color red alpha: 0.5);
layoutPolicy: ProportionalLayout new;
addMorph: (
Morph new
color: (Color yellow alpha: 0.5);
layoutPolicy: TableLayout new;
listDirection: #topToBottom;
listCentering: #center;
addMorph: (
Morph new extent: 100@2; color: Color black; hResizing: #spaceFill
)
)
fullFrame: (LayoutFrame fractions: (0@0 corner: 0.9 @ 0.9) offsets: nil)
)
fullFrame: (
LayoutFrame fractions: (0@0 corner: 1 @ 1) offsets: (0@0 corner: 0@100 negated)
);
openInWorld.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 19:13'!
layoutSample6
| rectangle string frame |
"set up the string"
string := StringMorph new contents: 'This is a string'.

"this is the trick - set up a layout frame so that
it will align the string at the top-center of the owner
but offset left by half of the string's width"
frame := LayoutFrame new.
frame leftFraction: 0.5 offset: string width // -2.
frame topFraction: 0 offset: 0.

"install it"
string layoutFrame: frame.

"the container"
rectangle := RectangleMorph new.
rectangle layoutPolicy: ProportionalLayout new.
rectangle addMorph: string.

"clip parent so string doesn't show outside"
rectangle clipSubmorphs: true.
rectangle openInHand.
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 19:14'!
layoutSample7
| rectangle string |
"the container"
rectangle := RectangleMorph new.

"this is the trick - set up a layout
so that it is oriented left to right and
then center the entire list"
rectangle layoutPolicy: TableLayout new.
rectangle listDirection: #leftToRight.
rectangle listCentering: #center.

"Note: the same effect could be achieved using:
rectangle listDirection: #topToBottom.
rectangle wrapCentering: #center.
This may work better if the entire contents
of the rectangle should be a vertical list"

"set up the string"
string := StringMorph new contents: 'This is a string'.
rectangle addMorph: string.

"clip parent so string doesn't show outside"
rectangle clipSubmorphs: true.
rectangle openInHand.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:37'!
morphicModifierSample
	^ActiveHand shiftPressed.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 20:15'!
selectRectangleFromUserSample
^Rectangle fromUser.
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/29/2012 23:19'!
simpleLoggerSample
	"SimpleLogger

SimpleLogger developed by Germn Arduino is available at http://ss3.gemstone.com/ss/SimpleLogger.html. SimpleLogger is a really simple text only logger.

It's simple to install, only point your Monticello Browser to:
"

	| aLogger |

"	MCHttpRepository location: 'http://ss3.gemstone.com/ss/SimpleLogger' user: '' password: "''.	"and load the latest version.

Use it is also simple:
"
	aLogger := G9Logger new.	"

Creates a new instance of SimpleLogger, opening a text file named for example: 15 July 2010 6#15#01 am.txt

Then, to log things on such file you can use the following messages:
"
	aLogger log: 'Text to log on the logfile'.	"Will log the phrase 'Text to log on the logfile on the logfile."
	aLogger logSeparator.	"Will log a line of '-' to separate sections on the logfile."
	aLogger logWithTimeStamp: 'This text was written at: '.	"Will log a the phrase 'This text was written at: 15 July 2010 6:24:03 am' in the logfile."
	aLogger closeLogFile	"Will close the log file, writing some closing text.
The complete session of the previous samples will generate this log file:

----------------------------------------------------------------
G9Logger started at:  15 July 2010 6:15:01 am
----------------------------------------------------------------
Text to log on the logfile
----------------------------------------------------------------
This text was written at:  15 July 2010 6:24:03 am
----------------------------------------------------------------
G9Logger ended at: 15 July 2010 6:27:09 am
----------------------------------------------------------------
-------G9Logger is a product from Arduino Software--------------
---Web: http://www.arduinosoftware.com---Mail: info@arsol.net---
"! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:34'!
timingSample
|list count thisTick nextTick|

list := Array new: 1000.
count := 0.
thisTick := Time millisecondClockValue.
[count < 1000] whileTrue:[
    nextTick := Time millisecondClockValue.
    nextTick = thisTick ifFalse:[
        count := count + 1.
        list at: count put: (nextTick - thisTick).
        thisTick := nextTick.
    ].
].! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/29/2012 21:34'!
trueTypeExample
	"Using TrueType"

	| smf |
	smf := TTSampleStringMorph new.
	smf loadFromURL: 'http://ireader.googlecode.com/files/arial.ttf'.
	smf string: 'Hello'.
	smf openInHand.
	smf color: Color green.
	smf string: 'True Type in Pharo'.
	smf edit.	"smf addCustomMenuItems: ? hand: ActiveHand. "
	smf printOn: Transcript.
	smf position: 10 @ 50! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/29/2012 22:55'!
trueTypeExample2
	"We need to use a TTFontReader for loading from a Stream.f"
	"Make sure to check the TTSampleStringMorph>>addCustomMenuItems:... and the Morph menu
	when it is created."

	| tfd ttm |
	tfd := TTFontDescription addFromTTFile: '/Users/philippeback/Angles Octagon.ttf'.
	ttm := TTSampleFontMorph font: tfd.
	ttm color: Color blue.
	ttm:=TTSampleStringMorph font: tfd.
	ttm string: 'SpiderMan'.
	ttm bounds: (0@0 extent: 500@300). "Scale!!"
	ttm color: Color red.
	ttm borderColor: Color blue.
	ttm borderWidth: 2.
	ttm openInHand! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 20:19'!
usageOfPenSample1
| myPen |
Display restoreAfter: [
   Display fillWhite.

myPen := Pen new.                                           "get graphic pen"
myPen squareNib: 1.
myPen color: (Color red).                                  "set pen color"
myPen home.                                                 "position pen at center of display"
myPen up.                                                   "makes nib unable to draw"
myPen down.                                                 "enable the nib to draw"
myPen north.                                                "points direction towards top"
myPen turn: -180.                                           "add specified degrees to direction"
myPen direction.                                            "get current angle of pen"
myPen go: 50.                                               "move pen specified number of pixels"
myPen location.                                             "get the pen position"
myPen goto: 200@200.                                        "move to specified point"
myPen place: 250@250.                                       "move to specified point without drawing"
myPen print: 'Hello World' withFont: (TextStyle default fontAt: 1).
Display extent.                                             "get display width@height"
Display width.                                              "get display width"
Display height.                                             "get display height"

].! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:51'!
usageOfPenSample2
	| pen |
	Display
		restoreAfter: [ 
			Display fillWhite.
			pen := Pen newOnForm: Display.
			pen defaultNib: 2.
			pen
				fill: [ :each | 
					6
						timesRepeat: [ 
							each
								go: 100;
								turn: 60 ] ]
				color: Color red ]! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:53'!
usageOfPenSample3
   "This is completely wrong in Pharo..."
	| pen |
	Display
		restoreAfter: [ 
			Display fillWhite.
			pen := Pen new.
			pen
				squareNib: 2;
				color: Color red;
				turn: 45.
			pen
				print:
					'The owl and the pussycat went to sea
in a beautiful pea green boat.'
				withFont: TextStyle defaultFont ]! !
